class Diamina{
  
  // propriedades da classe
  float xpos, ypos; // posição do átomo de nitrogênio à esquerda
  
  float w = 0; // define a abertura das ligações no átomo de nitrogênio à ESQUERDA (se seu valor é '1',
               // não desenha-se um dos átomos de hidrogênio)
               
  float u = 0; // define a abertura das ligações no átomo de nitrogênio à DIREITA (se seu valor é '1', 
               // não desenhamos um dos átomos de hidrogênio)
  
  // CONSTRUTORA
  Diamina(float x, float y){
    xpos = x;
    ypos = y;
  }
  
  // função que desenha a molécula de diamina
  void display(){
    pushMatrix();
    translate(xpos, ypos); // origem: átomo de nitrogênio mais à esquerda
    stroke(0);
    line(0, 0, comprimento/4, 0);
    pushMatrix();
    rotate( 4*PI/3 + w*PI/6);
    line(0, 0, comprimento/2, 0);
    noStroke();
    fill(122); // CINZA
    ellipse(comprimento/2, 0, comprimento/5, comprimento/5); // desenhamos um átomo de hidrogênio ligado ao de nitrogênio à esquerda
    popMatrix();
    pushMatrix();
    rotate(2*PI/3 + w*PI/3);
    stroke(0);
    line(0, 0, comprimento/4, 0);
    
    if(etapa == 0){ // só desenhamos este átomo se a etapa for 0
      pushMatrix();
      translate(comprimento/2, 0); // origem: segundo átomo de hidrogênio ligado ao de nitrogênio mais à esquerda
      rotate(w*PI);                              
      line(0, 0, -comprimento/4, 0);
      noStroke();
      fill(122); // CINZA
      ellipse(0, 0, comprimento/5, comprimento/5); // desenhamos o átomo de hidrogênio
      popMatrix();
    }
    
    noStroke();    
    fill(#08FF85); // VERDE
    ellipse(0, 0, 1.3*comprimento/5, 1.3*comprimento/5); // desenhamos o átomo de nitrogênio
    popMatrix();
    
    // para desenhar os carbonos internos à molécula, com seus hidrogênios ligados:
    for(int i = 1; i <= 6; i++){
      pushMatrix();
      translate(i*comprimento/2, 0);
      stroke(0);
      line(0, 0, 0, 5*comprimento/12);
      line(0, 0, 0, - 5*comprimento/12);
      line(0, 0, comprimento/4, 0);
      line(0, 0, - comprimento/4, 0);
      noStroke();
      fill(122); // CINZA
      ellipse(0, 5*comprimento/12, comprimento/5, comprimento/5);      // átomos de 
      ellipse(0, - 5*comprimento/12, comprimento/5, comprimento/5);    // hidrogênio
      fill(#91D6F7); // AZUL
      ellipse(0, 0, 1.3*(comprimento/5), 1.3*(comprimento/5)); // desenhamos o átomo de carbono
      popMatrix();
    }
    
    pushMatrix();
    translate(7*comprimento/2, 0); // origem: átomo de nitrogênio à direita
    stroke(0);
    line(0, 0, - comprimento/4, 0);
    pushMatrix();
    rotate( - PI/3 - u*PI/6); // o ângulo depende de 'u'
    line(0, 0, comprimento/2, 0);
    noStroke();
    fill(122); // CINZA
    ellipse(comprimento/2, 0, comprimento/5, comprimento/5); // desenhamos um dos átomos de hidrogênio ligados
    popMatrix();
    pushMatrix();
    rotate(PI/3 - u*PI/3); // o ângulo depende de 'u'
    stroke(0);
    line(0, 0, comprimento/4, 0);
    pushMatrix();
    
    // dependendo do valor assumido por 'u', mostramos (ou não) um dos átomos de hidrogênio ligado ao nitrogênio à direita
    if(u != 1){
      translate(comprimento/2, 0); // origem: segundo átomo de hidrogênio ligado ao nitrogênio à direita
      line(0, 0, - comprimento/4, 0);
      noStroke();
      fill(122); // CINZA
      ellipse(0, 0, comprimento/5, comprimento/5); // desenhamos o hidrogênio
    } 
   
    popMatrix();
    noStroke();
    fill(#08FF85); // VERDE
    ellipse(0, 0, 1.3*comprimento/5, 1.3*comprimento/5); // desenhamos o nitrogênio da direita
    popMatrix();    
    
    popMatrix();
    popMatrix();
  }
  
  // função que 'abre' as ligações do nitrogênio à esquerda ao mudar o valor de 'w'
  void abre(float v){
    if(w < 1)
      w += v;
    else
      w = 1;
  }
  
  // função que faz a mulécula se mover no plano
  void anda(float vx, float vy){
    xpos += vx;
    ypos += vy;
  }
  
  // define uma nova posição
  void setPosition(float x, float y){
    xpos = x;
    ypos = y;
  }
}
